<div class="container-custom">
  <form [formGroup]="editForm">
    <label style="padding-right: 30px; padding-top: 5px">{{'high_availability.high_availability_status' | translate}}</label>
    <label class="switch switch-pill switch-success" (change)="delete(deleteModal)">
      <input style="margin-bottom: 0px; margin-top: 1rem" type="checkbox" class="switch-input" checked
             formControlName="high_availability_status"
             [(ngModel)]="isChecked" (change)="checkValue(isChecked)">
      <span class="switch-slider" style=" margin-top: 1rem"></span>
    </label>
  </form>
</div>
<div class="container-custom" *ngIf="isChecked">
  <form [formGroup]="editForm">
    <ng-container formGroupName="config">
      <div class="card">
        <div class="card-header"><i class="fa fa-globe"></i>{{'high_availability.configuration' | translate}}</div>
        <div class="card-body">
          <div class="form-group row">
            <label class="col-md-2">{{'high_availability.mode' | translate}}</label>
            <div class="col-md-10">
              <select class="form-control" for="operation_mode_id" id="mode" name="operation_mode_id"
                      style="width: 40%;"
                      formControlName="operation_mode_id">
                <option [ngValue]="highAvailabilityMode.id"
                        *ngFor="let highAvailabilityMode of highAvailabilityModes; trackBy: trackBankBrandById">{{highAvailabilityMode.mode_name}}</option>
              </select>
            </div>
          </div>
          <div class="form-group row">
            <label for="device_priority" class="col-md-2">{{'high_availability.device_priority' | translate}}</label>
            <div class="col-md-10 form-inline">
              <input style="width: 40%;" class="form-control" name="device_priority" id="device_priority" type="number"
                     formControlName="device_priority">
              <div
                *ngIf="editForm.get('config.device_priority').invalid && editForm.get('config.device_priority').touched || editForm.get('config.device_priority').dirty">
              <span style="margin-left: 5px" class="form-text text-danger"
                    *ngIf="editForm.get('config.device_priority').errors?.required">
                        {{'error.validate.input_required' | translate}}
                      </span>
                <span style="margin-left: 5px" class="form-text text-danger"
                      *ngIf="editForm.get('config.device_priority').errors?.max">
                        {{'high_availability.max' | translate}}
                      </span>
              </div>
            </div>
          </div>
          <div class="form-group row">
            <label for="group_name" class="col-md-2">{{'high_availability.group_name' | translate}}</label>
            <div class="col-md-10 form-inline">
              <input type="text" style="width: 40%;" class="form-control" name="group_name" id="group_name"
                     formControlName="group_name">
              <div
                *ngIf="editForm.get('config.group_name').invalid && editForm.get('config.group_name').touched || editForm.get('config.group_name').dirty">
                <span style="margin-left: 5px" class="form-text text-danger"
                      *ngIf="editForm.get('config.group_name').errors?.required">
                        {{'error.validate.input_required' | translate}}
                      </span>
                <span style="margin-left: 5px" class="form-text text-danger"
                      *ngIf="editForm.get('config.group_name').errors?.maxlength">
                        {{'high_availability.max_group_name' | translate}}
                      </span>
              </div>
            </div>
          </div>
          <div class="form-group row">
            <label for="group_password" class="col-md-2">{{'high_availability.group_password' | translate}}</label>
            <div class="col-md-10 form-inline" style="width: 40%; display: inline-flex">
              <input type="password" style="width: 40%;" class="form-control" name="group_password" id="group_password"
                     formControlName="group_password">
<!--              <div class="input-group-append">-->
<!--                <button class="btn btn-dark" type="button"-->
<!--                  (click)="highAvailabilities.config.is_show_password.valueOf()"-->
<!--                  class="input-group-text"-->
<!--                  style="cursor: pointer;">-->
<!--                  <i-->
<!--                    [class]="highAvailabilities.config.is_show_password? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i>-->
<!--                </button>-->
<!--              </div>-->
              <div
                *ngIf="editForm.get('config.group_password').invalid && editForm.get('config.group_password').touched || editForm.get('config.group_password').dirty">
                <span style="margin-left: 5px" class="form-text text-danger"
                      *ngIf="editForm.get('config.group_password').errors?.required">
                        {{'error.validate.input_required' | translate}}
                      </span>
                <span style="margin-left: 5px" class="form-text text-danger"
                      *ngIf="editForm.get('config.group_password').errors?.maxlength">
                        {{'high_availability.max_group_password' | translate}}
                      </span>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="card">
        <div class="card-header"><i class="fa fa-globe"></i>{{'high_availability.heartbeat_configuration' | translate}}</div>
        <div class="card-body">
          <div class="form-group row">
            <label class="col-md-2">{{'high_availability.heartbeat_interface' | translate}}</label>
            <div class="col-md-10">
              <select class="form-control" name="heartbeat_interface_id" style="width: 40%;" id="heartbeat_interface_id"
                      for="heartbeat_interface_id" formControlName="heartbeat_interface_id">
                <option [ngValue]="networkInterface.id"
                        *ngFor="let networkInterface of networkInterfaces; trackBy: trackBankBrandById">{{networkInterface.name}}</option>
              </select>
            </div>
          </div>
          <div class="form-group row">
            <label class="col-md-2">{{'high_availability.heartbeat_network' | translate}}</label>
            <div class="col-md-10 form-inline">
              <input style="width: 40%;" class="form-control" type="text" id="heartbeat_network"
                     placeholder="10.10.10.0" formControlName="heartbeat_network">
              <div
                *ngIf="editForm.get('config.heartbeat_network').invalid && editForm.get('config.heartbeat_network').touched || editForm.get('config.heartbeat_network').dirty">
                <span style="margin-left: 5px" class="form-text text-danger"
                      *ngIf="editForm.get('config.heartbeat_network').errors?.required">
                        {{'error.validate.input_required' | translate}}
                      </span>
              </div>
              <input style=" margin-left: 1rem; width: 40%;" class="form-control" type="text" id="heartbeat_netmask"
                     placeholder="255.255.255.0" formControlName="heartbeat_netmask">
              <div
                *ngIf="editForm.get('config.heartbeat_netmask').invalid && editForm.get('config.heartbeat_netmask').touched || editForm.get('config.heartbeat_netmask').dirty">
                <span style="margin-left: 5px" class="form-text text-danger"
                      *ngIf="editForm.get('config.heartbeat_netmask').errors?.required">
                        {{'error.validate.input_required' | translate}}
                      </span>
              </div>
            </div>
          </div>
        </div>
      </div>
    </ng-container>
    <ng-container formGroupName="virtual_interface">
      <div class="card" *ngIf="networkInterfaces?.length > 0">
        <table class="table table-striped table-bordered">
          <thead>
          <tr>
            <th class="text-center">{{'network.name' | translate}}</th>
            <th class="text-center">{{'high_availability.enable' | translate}}</th>
            <th class="text-center">{{'high_availability.virtual_ip' | translate}}</th>
            <th class="text-center">{{'high_availability.priority' | translate}}</th>
          </tr>
          </thead>
          <tbody>
          <tr *ngFor="let virtual of getVirtualInterface.controls; let i = index" [formGroupName]="i">
            <td style="width: 40%">{{virtual.get('name').value}}</td>
            <td style="width: 10%" class="text-center">
              <div>
                <label class="switch switch-pill switch-success">
                  <input type="checkbox" class="switch-input" checked formControlName="is_enable">
                  <span class="switch-slider"></span>
                </label>
              </div>
            </td>
            <td style="width:34%">
              <span *ngIf="!virtual.get('is_enable').value">
              {{virtual.get('virtual_ip_address').value}}
              </span>
              <div *ngIf="virtual.get('is_enable').value">
                <input type="text" class="form-control" name="virtual_ip_address" id="virtual_ip_address"
                       formControlName="virtual_ip_address"
                       pattern="^((^\s*((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))\s*$)|(^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$))$">
              </div>
            </td>
            <td style="width: auto">
              <span *ngIf="!virtual.get('is_enable').value">
              {{virtual.get('priority').value}}
              </span>
              <div *ngIf="virtual.get('is_enable').value">
                <input type="text" class="form-control" name="priority" id="priority"
                       formControlName="priority">
              </div>
            </td>
          </tr>
          </tbody>
        </table>
      </div>
    </ng-container>
    <div class="form-group float-right">
      <button type="submit" class="btn btn-primary" id="save-entity" (click)="save()"
              [disabled]="editForm.invalid ">
        <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
      </button>
    </div>
  </form>
</div>

<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'high_availability.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="onchangeValue();modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'high_availability.delete_popup.message' | translate}}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger"
            (click)="modal.close('delete')">{{'common.delete' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="onchangeValue();modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>
